<?php

namespace AppBundle\Entity\Product;


use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;
use Dunglas\ApiBundle\Annotation\Iri;
use Symfony\Component\Serializer\Annotation\Groups;
use Symfony\Component\Validator\Constraints as Assert;
use AppBundle\Entity\Traits\TimestampableEntity;
use AppBundle\Entity\Traits\CreatorUpdaterEntity;

/**
 * Produit à facturer induit par une action ou un évènement, en fonction du contexte
 * (et pas suite à un choix de l'Access)
 *
 * @Iri("http://schema.org/FictionalIntangible")
 */
#[ORM\Entity]
class FictionalIntangible
{
    use TimestampableEntity;
    use CreatorUpdaterEntity;
    /**
     * @var int
     */
    #[ORM\Column(type: 'integer')]
    #[ORM\Id]
    #[ORM\GeneratedValue(strategy: 'AUTO')]
    #[Groups(['fictionalintangible'])]
    private $id;
    /**
     * @var string
     */
    #[ORM\Column(type: 'string', length: 100, nullable: true)]
    #[Assert\Type(type: 'string')]
    #[Groups(['fictionalintangible'])]
    private $label;
    /**
     * @var string
     */
    #[ORM\Column(type: 'string', nullable: true)]
    #[Assert\Type(type: 'string')]
    #[Assert\Choice(callback: ['AppBundle\Enum\Product\FictionalIntangibleTypeEnum', 'toArray'])]
    #[Groups(['fictionalintangible'])]
    private $type;
    /**
     * @var string
     */
    #[ORM\Column(type: 'string', nullable: true)]
    #[Assert\Type(type: 'string')]
    #[Assert\Choice(callback: ['AppBundle\Enum\Billing\PricingLineAdhesionEnum', 'toArray'])]
    #[Groups(['fictionalintangible'])]
    private $pricingLineAdhesion;
    /**
     * @var string
     */
    #[ORM\Column(type: 'string', nullable: true)]
    #[Assert\Type(type: 'string')]
    #[Assert\Choice(callback: ['\AppBundle\Enum\Billing\PeriodicityEnum', 'toArray'])]
    #[Groups(['intangible'])]
    private $billingPeriodicity;
    /**
     * Constructor
     */
    public function __construct()
    {
    }
    /**
     * Get id
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Sets id.
     *
     * @param int $id
     *
     * @return $this
     */
    public function setId($id)
    {
        $this->id = $id;

        return $this;
    }
    /**
     * Set label
     *
     * @param string $label
     *
     * @return FictionalIntangible
     */
    public function setLabel($label)
    {
        $this->label = $label;

        return $this;
    }
    /**
     * Get label
     *
     * @return string
     */
    public function getLabel()
    {
        return $this->label;
    }
    /**
     * Set type
     *
     * @param string $type
     *
     * @return FictionalIntangible
     */
    public function setType($type)
    {
        $this->type = $type;

        return $this;
    }
    /**
     * Get type
     *
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set pricingLineAdhesion
     *
     * @param string $pricingLineAdhesion
     *
     * @return FictionalIntangible
     */
    public function setPricingLineAdhesion($pricingLineAdhesion)
    {
        $this->pricingLineAdhesion = $pricingLineAdhesion;

        return $this;
    }
    /**
     * Get pricingLineAdhesion
     *
     * @return string
     */
    public function getPricingLineAdhesion()
    {
        return $this->pricingLineAdhesion;
    }
    /**
     * Set billingPeriodicity
     *
     * @param string $billingPeriodicity
     *
     * @return FictionalIntangible
     */
    public function setBillingPeriodicity($billingPeriodicity)
    {
        $this->billingPeriodicity = $billingPeriodicity;

        return $this;
    }
    /**
     * Get billingPeriodicity
     *
     * @return string
     */
    public function getBillingPeriodicity()
    {
        return $this->billingPeriodicity;
    }
}
